classdef Animator < handle
    % ANIMATOR Animator2D and Animator3D are its children. Defines style
    
    properties (Access = protected)
        settingsCommon = struct(...
            'MarkerSize',10,...
            'LineStyle','none',...
            'LineWidth',2);
        settingsAgents = struct('Marker','o');
        settingsVirtualLeader = struct('Marker','x');
        settingsTrails = struct(...
            'MarkerSize',8,...
            'LineStyle','none',...
            'LineWidth',1,...
            'Marker','.',...
            'Color',[0.5 0.5 0.5]);
        trailCoordinates = struct(...
            'x',[],'y',[],'z',[]);
        settingsObstacles = struct([]);
        obstacleColorspec = 'y';
        arrowsLinespecAgents = 'r';
        arrowsLinespecVL = 'g';
        axesDimensions
    end
    
    methods
        function this = Animator(coordinates)
            this.determineAxis(coordinates);
            grid on;
            hold on;
        end % constructor
    end
    
    methods (Abstract = true)
        animate(this,coordinates,adjacency,time,...
                showCommLinksSwitch,showTrailsSwitch,maxTrailLength,...
                axesDimSwitch,axesDimensionsManual,commObstaclesSwitch,...
                obstacles)
    end
    methods (Access = protected, Abstract = true)
        determineAxis(this,coordinates)
        resizeAxes(this,coordinates,axesDimSwitch,axesDimensionsManual)
        drawArrows(this,coordinates,adjacency)
        drawTrails(this,coordinates,maxTrailLength)
        plotAgentIds(this,coordinates,agentIds)
        drawObstacles(this,obstacles)
    end
    
end

