classdef GeneralizedAgent < handle
    %AGENT Summary of this class goes here
    %   Detailed explanation goes here
    
    properties (Access = protected)
        id = int32(0);              % unique identification number for each
                                    % agent
        y_k = [];                   % y(k) = [y_1,...,y_P]'
                                    % output for new state, 1xdim(C) vector 
        coordinates = [];           % spatial coordinates, 1x2 or 1x3 vector
        output2Coordinates = [];
        refInput = [];              % r(k+1) = [r_1,...,r_P]'
                                    % reference input, 1xdim(model.C) vector
    end
    
    methods
        function this = GeneralizedAgent(id,output2Coordinates,refInput)
            % initialize properties:
            this.id = id;
            this.output2Coordinates = output2Coordinates;
            this.refInput = refInput;
        end % constructor
        
        function id = getId(this)
            id = this.id;
        end % getID
        
        function coordinates = getCoordinates(this)
            coordinates = this.coordinates;
        end % getCoordinates
        
        function output = sendOutput(this)
            output = this.y_k;
        end % sendOutput
        
        function receiveRefInput(this,refInput)
            this.refInput = refInput;
        end % receiveRefInput
    end
    
    methods (Abstract = true)
        calculateStep(this,formationSpecSwitch)
    end
    
    methods (Access = protected)
        function calculateCoordinates(this)
            this.coordinates = this.output2Coordinates*this.y_k;
        end % calculateCoordinates
    end
    
    methods (Access = protected, Abstract = true)
        calculateOutput(this)
    end
end

