classdef Memory < handle
    %REPORTER Summary of this class goes here
    %   Detailed explanation goes here
    
    properties (Access = private)
        agentStorage = cell(0);   
        adjacencyStorage = cell(0);
    end
    
    methods
        function this = Memory()
        end % constructor
        
        function saveOutputs(this,formation,timestep)% maybe use formation outputs 
            for l = 1:formation.getNumberOfAgents() 
                storeId = formation.getAgentId(l);
                if storeId <= size(this.agentStorage,2)
                    this.agentStorage{storeId}.outputs(:,...
                        size(this.agentStorage{storeId}.outputs,2) + 1) = ...
                        formation.getAgent(l).sendOutput();
                    this.agentStorage{storeId}.timestep(...
                        size(this.agentStorage{storeId}.timestep,2) + 1) = ...
                        timestep;
                else this.addAgent(timestep,formation.getAgent(l).sendOutput());
                end
            end   
        end % saveOutputsAndErrors
        
        function outputs = getOutputs(this,agentId,row)
            outputs = this.agentStorage{agentId}.outputs(row,:);
        end %getOutputs
        
        function timesteps = getTimesteps(this,agentId)
            timesteps = this.agentStorage{agentId}.timestep;
        end % getTimesteps
        
        function agentStorage = getAgentStorage(this)
            agentStorage = this.agentStorage;
        end % getAgentStorage
        
        function adjacencyStorage = getAdjacencyStorage(this)
            adjacencyStorage = this.adjacencyStorage;
        end % getAdjacencyStorage
        
        function output = getBackDatedOutput(this,timestepsBack,agentId)
            if size(this.agentStorage,2) >= agentId && ...
                    timestepsBack <= size(this.agentStorage{agentId}.outputs,2)
                output = this.agentStorage{agentId}.outputs(...
                    :,size(this.agentStorage{agentId}.outputs,2) - ...
                    timestepsBack + 1);
            else output = NaN(size(this.agentStorage{1}.outputs,1),1);
            end % if
        end % getBackDatedOutput
        
        function saveAdjacency(this,adjacency,timestep)
            this.adjacencyStorage{size(this.adjacencyStorage,2) + 1} = struct(...
                'timestep',timestep,'adjacency',adjacency);
        end % saveAdjacency
    end
    
    methods (Access = private)
        function addAgent(this,timestep,initialOutput)
            this.agentStorage{size(this.agentStorage,2) + 1} = struct(...
                'outputs',initialOutput,'timestep',timestep);
            %this.agentStorageSize = this.agentStorageSize + 1;
        end % addAgent
    end
    
end

