%% Specify Agents and References
% 1. Load the agent and controller models
load copter_models K  % load only controller

% 2. Specify the agents        init. state  init. position
models{1} = QuadrocopterModel( K, zeros(12,1), [1 0 0]' );
models{2} = QuadrocopterModel( K, zeros(12,1), [2 0 0]' );
models{3} = QuadrocopterModel( K, zeros(12,1), [3 0 0]' );
models{4} = QuadrocopterModel( K, zeros(12,1), [4 0 0]' );
models{5} = QuadrocopterModel( K, zeros(12,1), [5 0 0]' );

% 3. Spatial Coordinates
output2Coordinates = [
    1 0 0;
    0 1 0;
    0 0 1];

% 4. Adjacency matrix
%    agent #  0 1 2 3 4 5
adjacency = [0 0 0 0 0 0; % this is the Reference point
            -1 0 1 1 0 0; % agent 1: receives from ref. point, agents 2 & 3
            -1 0 0 0 1 0; % agent 2: receives from ref. point, agent 4
             0 1 0 0 1 0; % agent 3: receives from agents 1 & 4
             0 0 1 1 0 0; % agent 4: receives from agents 2 & 3
             0 0 1 0 1 0];% agent 5: receives from agents 2 & 4

% 5. Absolute reference input for all agents:
absRefInput = [
    0   -1  0;    % agent 1
    -1  -2  0;    % agent 2
    1   -2  0;
    -1  -3  0;
    1   -3  0];   % agent 5

% Save to initialization.mat file
save Martas_init.mat   models output2Coordinates adjacency absRefInput;
